macro
: 1+ $40 1, ;              : 1- $48 1, ;
: swap $0687 2, ;          : drop $ad 1, ; 
: nip $04c683 3, ;         : false $f9 1, ;
: true $f8 1, ;

forth
: swap swap ;              : drop drop ;
: nip nip ;                : dup [ $fc4689 3, $fc768d 3, ] ;
: and [ $0623 2, ] nip ;   : or [ $060b 2, ] nip ;
: xor [ $0633 2, ] nip ;   : not -1 xor ;          

: @ [ $008b 2, ] ;         : ! [ $89adc289 , $ad02 2, ] ;
: c@ @ $ff and ;           : c! [ $adc289 3, $ad0288 3, ] ;

: hex 16 base ! ;          : decimal 10 base ! ;
: binary 2 base ! ;        : octal 8 base ! ;

: + [ $0603 2, ] nip ;     : * [ $26f7 2, ] nip ;
: - [ $ad0629 3, ] ;       : negate -1 * ;
: /mod [ $c389 2, $99ad 2, $fbf7 2, ] dup [ $d089 2, ] ;
: / /mod drop ;            : mod /mod nip ;
: 1+ 1+ ;                  : 1- 1- ;

: wsparse 32 parse ;       : lnparse 10 parse ;
: ( ') parse drop drop ;   : | lnparse drop drop ;

: >> [ $c189 2, $d3ad 2, $e8 1, ] ;
: << [ $c189 2, $d3ad 2, $e0 1, ] ;

: here h0 @ ;

macro
: f: wsparse find compile ;
: m: wsparse mfind compile ;
: ['] wsparse find m: literal ;

: : wsparse entry ;        : ( f: ( ;

: >r $ad50 2, ;            : r> $04ee83 3, $0689 2, $58 1, ;
: r m: r> $50 1, ;

: prior last @ >r last @ @ last ! 32 parse find compile r> last ! ;

: repeat here ;            : again compile ;
: next m: r> : until $48 1, $c009 2, $850f 2, here - 4 - , $ad 1, ;
: for here m: >r ;

: (if) $063b 2, $adad 2, 1, here 0 1, ;
: <>if $74 m: (if) ;       : =if  $75 m: (if) ;
: <if  $7e m: (if) ;       : >if  $7d m: (if) ;
: ?if  $72 1, here 0 1, ;
: then dup here swap - 1- swap c! $90 1, ;

forth
: allot here + h0 ! ;      : cells 4 * ;         : cell+ 4 + ;

: later r> r> swap >r >r ; : exit, $c3 1, ;
: create: wsparse entry ;  : variable 0 : variable: create , ;
: rot >r swap r> swap ;    : -rot rot rot ;
: tuck swap                : over swap dup -rot ;
: 2dup over over ;         : 2drop drop drop ;
: ' wsparse find ;         : alias create: last @ cell+ ! ;
: execute >r ;             : 0; dup 0 =if r> 2drop ;; then ;
: literal, m: literal ;

create list 5 cells allot
: loc: list @ 1+ cells list + list @ 1+ list ! last @ swap ! ;
: ;loc list @ cells list + list @ 1- list ! @ last ! ;

: fill swap repeat >r swap 2dup c! 1+ swap r> until 2drop ;
: move for swap 2dup c@ swap c! 1+ swap 1+ next 2drop ;
: pad here 1024 + ;        : >pad dup >r pad swap move pad r> ;

: " '" parse dup 0 <>if >pad then ;          : ." " type ;
loc:
  : string, here 20 + over swap literal, literal, ;
  here ] string, $eb 1, dup 1, for dup c@ 1, 1+ next drop $90 1, ;
;loc alias $,

loc:
  variable size            : update 1+ size @ + size ! ;
  : place here swap move here ;
  : make dup -rot place swap dup allot 0 1, update ;
  : free size @ negate allot 0 size ! ;
  here ] make later free ;
;loc alias zt

macro
: s" " $, ;                : ." m: s" ['] type compile ;

forth
: cr 10 emit ;             : space 32 emit ;
: . dup 0 <if '- emit negate then : u. # space ;

: words last repeat @ 0; dup 9 + dup 1- c@ type space again ;
reset

here ] ." Error: Word Not Found: " type cr ; word? !
: ok interpret ok ;  ' ok
." RetroForth 8.0  ::  Visit http://www.retroforth.org for updates" cr cr
: (esc) 27 emit type ;
: clear s" [2J" (esc)       : home s" [1;1H" (esc) ;
: normal s" [0m" (esc) ;    : bold s" [1m" (esc) ;

: black s" [30m" (esc) ;    : red s" [31m" (esc) ;
: green s" [32m" (esc) ;    : yellow s" [33m" (esc) ;
: blue s" [34m" (esc) ;     : magenta s" [35m" (esc) ;
: cyan s" [36m" (esc) ;     : white s" [37m" (esc) ;

: onBlack s" [40m" (esc) ;  : onRed     s" [41m" (esc) ;
: onGreen s" [42m" (esc) ;  : onYellow  s" [43m" (esc) ;
: onBlue  s" [44m" (esc) ;  : onMagenta s" [45m" (esc) ;
: onCyan  s" [46m" (esc) ;  : onWhite   s" [47m" (esc) ;
forth
variable blk    64 variable: #blks
: (block) blk @ : block 512 * there + ;
: (line) 64 * (block) + ;

: p blk @ 1- blk ! ;       : n blk @ 1+ blk ! ;
: d (line) 64 32 fill ;    : x (block) 512 32 fill ;
: eb (block) 1024 eval ;   : el (line) 64 eval ;
: e 0 el 1 el 2 el 3 el 4 el 5 el 6 el 7 el ;
: ia (line) + >r 10 parse r> swap move ;
: i 0 swap ia ;            : s blk ! ;
: \ 1 s e ;                : \f there #blks @ 512 * eval ; 

: blocks #blks ! ;          : new 0 block #blks @ 512 * 32 fill 0 s ;
new
loc:
 : row green dup 64 type 64 + cr ;
 : .rows 8 repeat dup 8 swap - red . >r row r> until ; 
 : .block ." Block: " blk @ . ;
 : x--- ." +---:---+---:---" ; 
 : --- white space space x--- x--- x--- x--- cr ;
 : v --- blk @ block .rows drop --- ;
 : .stack ."  Stack: "
 : .s 10 repeat dup [ $86048b 3, ] . until cr ;
 : status green .block .stack ;
 ' status ' .s ' v
;loc alias v alias .s alias status

loc:
 variable fid
 create fn 256 allot
 : erase fn 256 0 fill ;
 : use erase wsparse fn swap move ;
 : perm fn &0666 2 15 syscall drop ; 
 : open fn $202 2 5 syscall fid ! perm ;
 : close fid @ 1 6 syscall drop ;
 : # #blks @ 512 * ;
 : w open fid @ there # 3 4 syscall drop close ;
 : r new open fid @ there # 3 3 syscall drop close ;
 ' w ' r ' use
;loc alias use alias r alias w
: load use f: r ;
forth
loc:
: c1 160 repeat space until s" [11;1H" (esc) ;
 variable edit?
 : exit 1 edit? ! ;
 : exit! 0 edit? ! ;
 : edit onBlack clear
 : .1 edit? @ 1 =if exit! ;; then home v c1 status white interpret .1 ;
' exit ' edit
;loc  alias edit  alias exit
